Dice HDU - 5012(bfs)

Dice HDU - 5012

 There are 2 special dices on the table. On each face of the dice, a distinct number was written. Consider a 1.a 2,a 3,a 4,a 5,a 6 to be numbers written on top face, bottom face, left face, right face, front face and back face of dice A. Similarly, consider b 1.b 2,b 3,b 4,b 5,b 6 to be numbers on specific faces of dice B. It’s guaranteed that all numbers written on dices are integers no smaller than 1 and no more than 6 while a i ≠ a j and b i ≠ b j for all i ≠ j. Specially, sum of numbers on opposite faces may not be 7.

At the beginning, the two dices may face different(which means there exist some i, a i ≠ b i). Ddy wants to make the two dices look the same from all directions(which means for all i, a i = b i) only by the following four rotation operations.(Please read the picture for more information)


Now Ddy wants to calculate the minimal steps that he has to take to achieve his goal.

Input
There are multiple test cases. Please process till EOF.

For each case, the first line consists of six integers a 1,a 2,a 3,a 4,a 5,a 6, representing the numbers on dice A.

The second line consists of six integers b 1,b 2,b 3,b 4,b 5,b 6, representing the numbers on dice B.

Output
For each test case, print a line with a number representing the answer. If there’s no way to make two dices exactly the same, output -1.
Sample Input

1 2 3 4 5 6
1 2 3 4 5 6
1 2 3 4 5 6
1 2 5 6 4 3
1 2 3 4 5 6
1 4 2 5 3 6

Sample Output

0
3
-1

题意:

给定两个魔方的状态,问能不能通过滚动从状态1到状态2,输出最小步数,不可能输出-1

分析:

一共就四种转移方式,左右滚前后滚,只要找准每个数组的变化方式bfs即可,只要能转移,不会超过三步,所以可以直接bfs

当时找了半天规律,原来就是暴力。。。。

#include <bits/stdc++.h>
using namespace std;
const int maxn = 1e5+10;
typedef long long ll;
string s,e;
set<string> se;
struct node{
    string x;
    int step;
};
void bfs(){
    se.clear();
    queue<node> que;
    que.push((node){s,0});
    se.insert(s);
    string p;
    while(!que.empty()){
        node tmp = que.front();
        que.pop();
        if(tmp.x == e){
            printf("%d\n",tmp.step);
            return;
        }
        //left
        p = "";
        p += tmp.x[2];
        p += tmp.x[3];
        p += tmp.x[1];
        p += tmp.x[0];
        p += tmp.x[4];
        p += tmp.x[5];
        if(!se.count(p)){
            que.push((node){p,tmp.step+1});
            se.insert(p);
        }
        //right
        p = "";
        p += tmp.x[3];
        p += tmp.x[2];
        p += tmp.x[0];
        p += tmp.x[1];
        p += tmp.x[4];
        p += tmp.x[5];
        if(!se.count(p)){
            que.push((node){p,tmp.step+1});
            se.insert(p);
        }
        //front
        p = "";
        p += tmp.x[4];
        p += tmp.x[5];
        p += tmp.x[2];
        p += tmp.x[3];
        p += tmp.x[1];
        p += tmp.x[0];
        if(!se.count(p)){
            que.push((node){p,tmp.step+1});
            se.insert(p);
        }
        p = "";
        p += tmp.x[5];
        p += tmp.x[4];
        p += tmp.x[2];
        p += tmp.x[3];
        p += tmp.x[0];
        p += tmp.x[1];
        if(!se.count(p)){
            que.push((node){p,tmp.step+1});
            se.insert(p);
        }
    }
    printf("-1\n");
    return;
}
int main(){
    int a[10],b[10];
    while(~scanf("%d",&a[1])){
        for(int i = 2; i <= 6; i++){
            scanf("%d",&a[i]);
        }
        for(int i = 1; i <= 6; i++){
            scanf("%d",&b[i]);
        }
        s = e = "";
        for(int i = 1; i <= 6; i++){
            s += a[i] + '0';
            e += b[i] + '0';
        }
        bfs();
    }
    return 0;
}

猜你喜欢

转载自blog.csdn.net/codeswarrior/article/details/82491308